# Модули
## Что такое модуль?
Определение модуля - функционально законченный фрагмент программы. Что это значит для нас? В библиотеке модули используются, чтобы объединять набор типов в какое-нибудь единое целое, чтобы потом была возможность его использовать, то есть создавать иеархичность где типы на самом низком уровне, а модули на уровне повыше. Также существуют еще более высокий уровень -Сборка, но о ней описано в следующей главе.

Как пример у нас может быть модуль регистрации, в который входят такие типы как: классы для показа окон регистрации, классы для работы с сервером регистрации, вспомогательные классы.

## Создание модуля
Попробуем объямить наш модуль. Для этого нам нужно отнаследоватся от протокола: DIModule, и реализовать метод load(builder). Это можно сделать следующим образом:
```Swift
class RegistrationModule: DIModule {
  func load(builder builder: DIContainerBuilder) {
    builder.register...
  }
}
```

Как видите ничего сложно в объявлении модуля нету. Это обычный класс, который имеет один метод, внутри которого мы регестрируем с помощью обычных средств наши типы.
Создается модуль еще проще: `RegistationModule()`, мы просто вызываем его конструктор. Но как типы в нашей программе так и модули, не имеют смысла без регистрации.

## Регистрация модуля
При регистрации модуля, не происходит никакой магии - просто все типы которые описаны внутри модуля будут зарегестрированы в билдере в котором мы его регистрируете. Вы можете зарегестрировать модуль сделующим образом:
```Swift
builder.register(module: RegistrationModule())
```